/* © 2024 Dummy */

/*   Copyright 2018-2021 Prebid.org, Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 CHANGE NOTICE: The file content was modified to rebrand the work, adapt the product for the new use case, and change the distribution license.
 The patch to the original code is available in the TestAdDummy repository.
 All changes after applying the patch are made under the new license and copyrights mentioned at the beginning of this file.
*/

#import <UIKit/UIKit.h>

#import "DummyAdModalManagerDelegate.h"
#import "DummyAdModalViewControllerDelegate.h"
#import "DummyAdVoidBlock.h"

@class DummyAdModalState;
@class DummyAdDeferredModalState;
@class DummyAdAbstractCreative;
@class DummyAdModalViewController;
@class DummyAdModalState;

NS_ASSUME_NONNULL_BEGIN

@interface DummyAdModalManager: NSObject <DummyAdModalViewControllerDelegate>

@property (nonatomic, strong, nullable) DummyAdModalViewController *modalViewController;

//The VC class to use to display modals. Defaults is nil.
@property (nullable) Class modalViewControllerClass;

- (instancetype)init;
- (instancetype)initWithDelegate:(nullable id<DummyAdModalManagerDelegate>)delegate NS_DESIGNATED_INITIALIZER;

- (nullable DummyAdVoidBlock)pushModal:(DummyAdModalState *)state
            fromRootViewController:(UIViewController *)fromRootViewController
                          animated:(BOOL)animated
                     shouldReplace:(BOOL)shouldReplace
                 completionHandler:(nullable DummyAdVoidBlock)completionHandler;

- (void)pushDeferredModal:(DummyAdDeferredModalState *)deferredModalState;

- (void)dismissAllInterstitialsIfAny;
- (void)creativeDisplayCompleted:(DummyAdAbstractCreative *)creative;
- (void)forceOrientation:(UIInterfaceOrientation)forcedOrientation NS_SWIFT_NAME(forceOrientation(_:));

- (void)hideModalAnimated:(BOOL)animated completionHandler:(nullable DummyAdVoidBlock)completionHandler;
- (void)backModalAnimated:(BOOL)animated fromRootViewController:(nullable UIViewController *)fromRootViewController completionHandler:(nullable DummyAdVoidBlock)completionHandler;

@end

NS_ASSUME_NONNULL_END
