/* © 2024 Dummy */

/*   Copyright 2018-2021 Prebid.org, Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 CHANGE NOTICE: The file content was modified to rebrand the work, adapt the product for the new use case, and change the distribution license.
 The patch to the original code is available in the TestAdDummy repository.
 All changes after applying the patch are made under the new license and copyrights mentioned at the beginning of this file.
*/

#import <Foundation/Foundation.h>
#import "DummyAdORTBBidExtSkadn.h"

@protocol DummyAdTransactionDelegate;

@class WKWebView;
@class UIView;
@class DummyAdModalManager;
@class DummyAdAdConfiguration;
@class DummyAdCreativeModel;
@class DummyAdAbstractCreative;
@class DummyAdAdDetails;
@class DummyAdOpenMeasurementSession;
@class DummyAdOpenMeasurementWrapper;
@class DummyAdORTBBidExtSkadn;

@protocol TestAdDummyServerConnectionProtocol;

NS_ASSUME_NONNULL_BEGIN
@interface DummyAdTransaction: NSObject

@property (nonatomic, readonly, nonnull) DummyAdAdConfiguration *adConfiguration; // If need to change use resetAdConfiguration
@property (nonatomic, strong) NSMutableArray<DummyAdAbstractCreative *> *creatives;
@property (nonatomic, strong) NSArray<DummyAdCreativeModel *> *creativeModels;
@property (nonatomic, strong, nullable) DummyAdOpenMeasurementSession *measurementSession;
@property (nonatomic, strong) DummyAdOpenMeasurementWrapper *measurementWrapper;

@property (nonatomic, strong, nullable) DummyAdORTBBidExtSkadn *skadnInfo;
@property (nonatomic, strong, nullable) NSString *impURL; // bidResponse.ext.mobilesdk.events.imp
@property (nonatomic, strong, nullable) NSString *winURL; // bidResponse.ext.mobilesdk.events.win

@property (atomic, weak, nullable) id<DummyAdTransactionDelegate> delegate;

- (instancetype)init NS_UNAVAILABLE;
- (instancetype)initWithServerConnection:(id<TestAdDummyServerConnectionProtocol>)connection
                         adConfiguration:(DummyAdAdConfiguration *)adConfiguration
                                  models:(NSArray<DummyAdCreativeModel *> *)creativeModels NS_DESIGNATED_INITIALIZER;

- (void)startCreativeFactory;
- (nullable DummyAdAdDetails *)getAdDetails;
- (nullable DummyAdAbstractCreative *)getFirstCreative;
- (nullable DummyAdAbstractCreative *)getCreativeAfter:(DummyAdAbstractCreative *)creative;
- (nullable NSString*)revenueForCreativeAfter:(DummyAdAbstractCreative *)creative;
- (void)resetAdConfiguration:(DummyAdAdConfiguration *)adConfiguration;

@end
NS_ASSUME_NONNULL_END
